## Code Analysis, Continuous Integration and Test Coverage

| Code Analysis Service | Badge |
| --------------------- |:-----:|
| Code Climate          | [![Maintainability](https://api.codeclimate.com/v1/badges/e0d6b8024f0ffa7682c9/maintainability)](https://codeclimate.com/github/theblackwidower/KanaQuiz/maintainability) |
| Codacy                | [![Codacy Badge](https://api.codacy.com/project/badge/Grade/b0af5712d54745ada2893d82c55a680b)](https://www.codacy.com/app/theblackwidower/KanaQuiz?utm_source=github.com&amp;utm_medium=referral&amp;utm_content=theblackwidower/KanaQuiz&amp;utm_campaign=Badge_Grade) |

| CI Server | Badge&nbsp;with&nbsp;status | My Review |
| --------- |:---------------------------:| --------- |
| Travis CI | master:<br />[![Build Status](https://travis-ci.org/theblackwidower/KanaQuiz.svg?branch=master)](https://travis-ci.org/theblackwidower/KanaQuiz)<br />develop:<br />[![Build Status](https://travis-ci.org/theblackwidower/KanaQuiz.svg?branch=master)](https://travis-ci.org/theblackwidower/KanaQuiz) | ★★★☆☆<br />Mostly automated. Handles Android pretty well, but emulation support is limited to Android 5.1 (API 22), at the latest. |
| Circle CI | [![CircleCI](https://circleci.com/gh/theblackwidower/KanaQuiz.svg?style=shield)](https://circleci.com/gh/theblackwidower/KanaQuiz) | ★☆☆☆☆<br />Pretty good, but does not handle Android emulation. The only way to run Instrumented Tests is to take advantage of Firebase Test Lab remote testing, which has problems with automated result collecting, unless you're willing to pay for a results bucket. |
| Codeship  | master:<br />[![Codeship Status for theblackwidower/KanaQuiz](https://app.codeship.com/projects/7db68d50-ff29-0135-aeeb-56b253369268/status?branch=master)](https://app.codeship.com/projects/279635)<br />develop:<br />[![Codeship Status for theblackwidower/KanaQuiz](https://app.codeship.com/projects/7db68d50-ff29-0135-aeeb-56b253369268/status?branch=develop)](https://app.codeship.com/projects/279635) | ★★★★☆<br />Highly customizable. Build scripts can be written like any Linux Bash script. Even includes a special debug mode, allowing direct access to build environments through SSH, where one can experiment with build commands in the environment they run. However, it currently seems to have a problem with Android emulators, where builds will occasionally fail to install, but work on retry. Don't know what's going on. |
| Semaphore | master:<br />[![Build Status](https://semaphoreci.com/api/v1/theblackwidower/kanaquiz/branches/master/shields_badge.svg)](https://semaphoreci.com/theblackwidower/kanaquiz)<br />develop:<br />[![Build Status](https://semaphoreci.com/api/v1/theblackwidower/kanaquiz/branches/develop/shields_badge.svg)](https://semaphoreci.com/theblackwidower/kanaquiz) | ★★★★★<br />Highly customizable. Much like Codeship, build scripts can be written like any Linux Bash script, and it's very user friendly. Includes a special 'Launch SSH' feature to allow direct access to build environments through SSH. Also, unlike Codeship, it automatically runs builds on pull requests. |

| Coverage Reporter | Badge&nbsp;with&nbsp;percentage | My Review |
| ----------------- |:-------------------------------:| --------- |
| Coveralls         | master:<br />[![Coverage Status](https://coveralls.io/repos/github/theblackwidower/KanaQuiz/badge.svg?branch=master)](https://coveralls.io/github/theblackwidower/KanaQuiz?branch=master)<br />develop:<br />[![Coverage Status](https://coveralls.io/repos/github/theblackwidower/KanaQuiz/badge.svg?branch=develop)](https://coveralls.io/github/theblackwidower/KanaQuiz?branch=develop) | ☆☆☆☆☆<br />Only reports on unit tests, because they will not accept more than one report, or provide utilities for merging. |
| Codecov           | master:<br />[![codecov](https://codecov.io/gh/theblackwidower/KanaQuiz/branch/master/graph/badge.svg)](https://codecov.io/gh/theblackwidower/KanaQuiz)<br />develop:<br />[![codecov](https://codecov.io/gh/theblackwidower/KanaQuiz/branch/develop/graph/badge.svg)](https://codecov.io/gh/theblackwidower/KanaQuiz) | ★★★★★<br />Best report interface. Submission utility intuitively collects and submits reports with a single command, and site itself is intuitive and complete. |
| Code Climate      | [![Test Coverage](https://api.codeclimate.com/v1/badges/e0d6b8024f0ffa7682c9/test_coverage)](https://codeclimate.com/github/theblackwidower/KanaQuiz/test_coverage) | ★★★☆☆<br />Bundled with code analysis service. Submission utility can convert reports to JSON, and merge as many JSON reports as you like. |
| Codacy            | [![Codacy Badge](https://api.codacy.com/project/badge/Coverage/b0af5712d54745ada2893d82c55a680b)](https://www.codacy.com/app/theblackwidower/KanaQuiz?utm_source=github.com&utm_medium=referral&utm_content=theblackwidower/KanaQuiz&utm_campaign=Badge_Coverage) | ★★★☆☆<br />Bundled with code analysis service. Submission utility allows you to submit multiple reports, so it's ideal for parallel testing. |
